import socket
import tkinter as tk
import time
import webbrowser
import tkinter.font as tkFont

class IPEntryWindow:
    def __init__(self, master, callback):
        self.error = False
        self.master = master
        self.callback = callback
        master.title("Enter IP Address")
        master.geometry("420x740")
        master.config(bg = "black")
        
        self.link1 = tk.Label(master = master, text = "AeroAudio.eu", bg = "black", fg = "aqua", cursor = "hand2")
        self.link1.pack(side = tk.TOP)
        font = tkFont.Font(self.link1, self.link1.cget("font"))
        font.configure(underline = True)
        self.link1.configure(font = font)
        self.link1.bind("<Button>", lambda e: self.link("https://www.aeroaudio.eu/"))
        self.link1.bind("<Enter>", self.link_on_enter)
        self.link1.bind("<Leave>", self.link_on_leave)
        self.image = tk.PhotoImage(file = "Logo_AeroAudio.png").subsample(2)
        tk.Label(master = master, image = self.image, bg = "black").pack(side = tk.TOP)
        tk.Label(master = master, bg = "black").pack(pady = 10)

        tk.Label(master = master, text = "Enter IP address:", bg = "black", fg = "white").pack()
        self.ip_entry = tk.Entry(master = master)
        self.ip_entry.pack()
        self.connect_button = tk.Button(master = master, text = "Connect", command = self.connect, bg = "white", cursor = "hand2")
        self.connect_button.pack(pady = 5)
        self.connect_button.bind("<Enter>", self.connect_on_enter)
        self.connect_button.bind("<Leave>", self.connect_on_leave)
        tk.Label(master = master, bg = "black").pack(pady = 10)
        
        tk.Label(master = master, text = "Select the colors you've chosen on the local website:", bg = "black", fg = "white").pack()
        tk.Label(master = master, text = "Select color for LED1:", bg = "black", fg = "white").pack()
        self.led1_color_var = tk.StringVar(master)
        self.led1_color_var.set("red")
        led1_colors = ["red", "green", "cyan", "blue", "yellow", "purple", "orange", "white"]
        self.led1_color_menu = tk.OptionMenu(master, self.led1_color_var, *led1_colors)
        self.led1_color_menu.config(bg = "red", activebackground = "red", cursor = "hand2")
        self.led1_color_menu["menu"].config(bg = "black", fg = "white")
        self.led1_color_menu.pack()
        self.led1_color_var.trace_add("write", self.update_color_led1_menu_bg)

        tk.Label(master = master, text = "Select color for LED2:", bg = "black", fg = "white").pack()
        self.led2_color_var = tk.StringVar(master)
        self.led2_color_var.set("green")
        led2_colors = ["red", "green", "cyan", "blue", "yellow", "purple", "orange", "white"]
        self.led2_color_menu = tk.OptionMenu(master, self.led2_color_var, *led2_colors)
        self.led2_color_menu.config(bg = "green", activebackground = "green", cursor = "hand2")
        self.led2_color_menu["menu"].config(bg = "black", fg = "white")
        self.led2_color_menu.pack()
        self.led2_color_var.trace_add("write", self.update_color_led2_menu_bg)

        tk.Label(master = master, text = "Select color for Standby:", bg = "black", fg = "white").pack()
        self.standby_color_var = tk.StringVar(master)
        self.standby_color_var.set("blue")
        standby_colors = ["red", "green", "cyan", "blue", "yellow", "purple", "orange", "white"]
        self.standby_color_menu = tk.OptionMenu(master, self.standby_color_var, *standby_colors)
        self.standby_color_menu.config(bg = "blue", activebackground = "blue", cursor = "hand2")
        self.standby_color_menu["menu"].config(bg = "black", fg = "white")
        self.standby_color_menu.pack()
        self.standby_color_var.trace_add("write", self.update_color_standby_menu_bg)
        tk.Label(master = master, bg = "black").pack(pady = 5)
        
        self.tcp_flag = tk.IntVar()
        self.dhd_flag = tk.IntVar()
        self.c1 = tk.Checkbutton(master = master, text="TCP", variable=self.tcp_flag, cursor = "hand2", bg = "black", fg = "white", activebackground = "black", activeforeground = "white", selectcolor = "grey26")
        self.c1.pack()
        self.c2 = tk.Checkbutton(master = master, text="DHD", variable=self.dhd_flag, cursor = "hand2", bg = "black", fg = "white", activebackground = "black", activeforeground = "white", selectcolor = "grey26")
        self.c2.pack()
        
        self.error_label = tk.Label(master = master, text = "Error: none",bg = "black", fg = "lime green")
        self.error_label.pack(pady = 10)
        
        tk.Label(master = master, text = "Exit:", bg = "black", fg = "white").pack()
        self.close_img = tk.PhotoImage(file="home.png").subsample(10)
        self.exit_button = tk.Button(master = master, image = self.close_img, command = self.close_ip, bg = "black", activebackground = "black", cursor = "hand2")
        self.exit_button.pack(pady = 3)
    
    def get_selected_mode(self):
        tcp = self.tcp_flag.get()
        dhd = self.dhd_flag.get()
        if tcp == 1 and dhd == 1:
            self.error = True
        elif tcp == 1 and dhd == 0:
            self.error = False
            return "TCP"
        elif dhd == 1 and tcp == 0:
            self.error = False
            return "DHD"
        else:
            self.error = False
            
    def update_color_led1_menu_bg(self, *args):
        selected_color = self.led1_color_var.get()
        bg_color = selected_color
        self.led1_color_menu.configure(bg = bg_color, activebackground = bg_color)
        
    def update_color_led2_menu_bg(self, *args):
        selected_color = self.led2_color_var.get()
        bg_color = selected_color
        self.led2_color_menu.configure(bg = bg_color, activebackground = bg_color)
        
    def update_color_standby_menu_bg(self, *args):
        selected_color = self.standby_color_var.get()
        bg_color = selected_color
        self.standby_color_menu.configure(bg = bg_color, activebackground = bg_color)
    
    def connect(self):   
        entered_ip = self.ip_entry.get()
        led1_color = self.led1_color_var.get()
        led2_color = self.led2_color_var.get()
        standby_color = self.standby_color_var.get()
        protocol = self.get_selected_mode()
        if self.error == False:
            if protocol == None:
                self.error_label.config(text = "Select a protocol", fg = "red")
            else:
                if self.callback(entered_ip, led1_color, led2_color, standby_color, protocol):
                        self.master.destroy()
                else:
                    self.error_label.config(text="Error: invalid IP address " + entered_ip, fg="red")
                    print("Invalid IP address " + entered_ip)
        else:
            self.error_label.config(text = "Only 1 protocol can be chosen", fg = "red")
            
    def link(self, url):
        webbrowser.get("C:/Program Files/Google/Chrome/Application/chrome.exe %s").open(url)
    
    def link_on_enter(self, e):
        self.link1.config(fg = "light blue")

    def link_on_leave(self, e):
        self.link1.config(fg = "aqua")
        
    def connect_on_enter(self, e):
        self.connect_button.config(bg = "SystemButtonFace", fg = "black")

    def connect_on_leave(self, e):
        self.connect_button.config(bg = "white", fg = "black")
        
    def close_ip(self):
        self.master.destroy()
        self.master.quit()
        
class DHDEntryWindow():
    def __init__(self, master,tcp_app):
        self.auto_flag = False
        self.led1_button = False
        self.led2_button = False
        self.auto_interval = 260
        self.master = master
        self.tcp_app = tcp_app
        self.ip = self.tcp_app.server_address[0]
        self.led1_color = self.tcp_app.led1_color
        self.led2_color = self.tcp_app.led2_color
        self.standby_color = self.tcp_app.standby_color
        master.title("DHD LED Control App")
        master.geometry("430x580")
        master.config(bg = "black")
        
        self.link1 = tk.Label(master = master, text = "AeroAudio.eu", bg = "black", fg = "aqua", cursor = "hand2")
        font = tkFont.Font(self.link1, self.link1.cget("font"))
        font.configure(underline = True)
        self.link1.configure(font = font)
        self.link1.bind("<Button>", lambda e: self.link("https://www.aeroaudio.eu/"))
        self.link1.bind("<Enter>", self.link_on_enter)
        self.link1.bind("<Leave>", self.link_on_leave)
        self.image = tk.PhotoImage(file = "Logo_AeroAudio.png").subsample(2)
        self.image_label = tk.Label(master = master, image = self.image, bg = "black")
        
        self.current_color = tk.Label(master = master, text = "Current color:", bg = "black", fg = "white")
        self.color_led_label = tk.Label(master = master, bg = tcp_app.standby_color, padx = 15, pady = 5)
        
        self.auto_label = tk.Label(master = master, text = "Automatic disabled", bg = "black", fg = "white")
        self.auto_on = tk.Button(master = master, text = "Automatic on", command = self.toggle_auto, cursor = "hand2", bg = self.led1_color, activebackground = self.led2_color)
        self.auto_on.bind("<Enter>", self.auto_on_enter)
        self.auto_on.bind("<Leave>", self.auto_on_leave)
        self.auto_off = tk.Button(master = master, text = "Automatic off", command = self.stop_auto, cursor = "hand2", bg = self.led2_color, activebackground = self.led1_color)
        self.auto_off.bind("<Enter>", self.stop_auto_on_enter)
        self.auto_off.bind("<Leave>", self.stop_auto_on_leave)

        self.led1_on_button = tk.Button(master = master, text = "LED1 on", command = self.toggle_led1_on, bg = "white", fg = "black", cursor = "hand2", width = 7)
        self.led1_off_button = tk.Button(master = master, text = "LED1 off", command = self.toggle_led1_off, bg = "white", fg = "black", cursor = "hand2", width = 7)
        self.led2_on_button = tk.Button(master = master, text = "LED2 on", command = self.toggle_led2_on, bg = "white", fg = "black", cursor = "hand2", width = 7)
        self.led2_off_button = tk.Button(master = master, text = "LED2 off", command = self.toggle_led2_off, bg = "white", fg = "black", cursor = "hand2", width = 7)
        
        self.error_label = tk.Label(master = master, text = "Error: none", bg = "black", fg = "lime green")
        
        self.exit_label = tk.Label(master = master, text = "Exit:", bg = "black", fg = "white")
        self.close_img = tk.PhotoImage(file="home.png").subsample(10)
        self.exit_button = tk.Button(master = master, image = self.close_img, command = self.close_dhd, bg = "black", activebackground = "black", cursor = "hand2")
        
        self.link1.grid(row = 0, column = 2, columnspan = 2)
        self.image_label.grid(row = 1, column = 2, columnspan = 2)
        tk.Label(master = master, width = 2, bg = "black").grid(row = 1, column = 0)
        tk.Label(master = master, width = 2, bg = "black").grid(row = 1, column = 4)
        tk.Label(master = master, height = 1, bg = "black").grid(row = 2, column = 0)
        self.current_color.grid(row = 3, column = 2, columnspan = 2)
        self.color_led_label.grid(row = 4, column = 2, columnspan = 2)
        tk.Label(master = master, height = 1, bg = "black").grid(row = 5, column = 0)
        self.auto_label.grid(row = 6, column = 2, columnspan = 2)
        self.auto_on.grid(row = 7, column = 2, columnspan = 2)
        self.auto_off.grid(row = 8, column = 2, columnspan = 2)
        tk.Label(master = master, height = 1, bg = "black").grid(row = 9, column = 0)
        tk.Label(master = master, text = "LED1:", bg = "black", fg = "white").grid(row = 10, column = 1, columnspan = 2)
        tk.Label(master = master, text = "LED2:", bg = "black", fg = "white").grid(row = 10, column = 3, columnspan = 2)
        self.led1_on_button.grid(row = 11, column = 1, columnspan = 2)
        self.led1_off_button.grid(row = 12, column = 1, columnspan = 2)
        self.led2_on_button.grid(row = 11, column = 3, columnspan = 2)
        self.led2_off_button.grid(row = 12, column = 3, columnspan = 2)
        tk.Label(master = master, height = 1, bg = "black").grid(row = 13, column = 0)
        self.exit_label.grid(row = 15, column = 2, columnspan = 2)
        self.error_label.grid(row = 14, column = 2, columnspan = 2)
        self.exit_button.grid(row = 16, column = 2, columnspan = 2)
    
    def stop_auto_on_enter(self, e):
        self.auto_off.config(bg = self.led1_color)

    def stop_auto_on_leave(self, e):
        self.auto_off.config(bg = self.led2_color)
    
    def auto_on_enter(self, e):
        self.auto_on.config(bg = self.led2_color)

    def auto_on_leave(self, e):
        self.auto_on.config(bg = self.led1_color)
    
    def toggle_auto(self):
        self.auto_label.config(text = "Automatic enabled")
        self.auto_flag = True
        self.auto_change_led()
        
    def auto_change_led(self):
        if self.auto_flag:
            if self.color_led_label.cget("bg") == self.led1_color:
                self.toggle_led("AERO\03\00\11P\00\00\00\01\01")
                self.toggle_led("AERO\03\00\11P\00\00\00\00\00")
                self.color_led_label.config(bg = self.led2_color)
            else:
                self.toggle_led("AERO\03\00\11P\00\00\00\00\01")
                self.toggle_led("AERO\03\00\11P\00\00\00\01\00")
                self.color_led_label.config(bg = self.led1_color)
            self.master.after(self.auto_interval, self.auto_change_led)
            
    def stop_auto(self):
        self.auto_flag = False
        self.auto_label.config(text = "Automatic disabled")
        self.color_led_label.config(bg = self.standby_color)
        self.toggle_led("AERO\03\00\11P\00\00\00\00\00")
        self.toggle_led("AERO\03\00\11P\00\00\00\01\00")
    
    def link(self, url):
        webbrowser.get("C:/Program Files/Google/Chrome/Application/chrome.exe %s").open(url)
    
    def link_on_enter(self, e):
        self.link1.config(fg = "light blue")

    def link_on_leave(self, e):
        self.link1.config(fg = "aqua")
        
    def close_dhd(self):
        self.master.destroy()
        self.master.quit()
    
    def toggle_led1_on(self):
        self.led1_button = True
        self.toggle_led("AERO\03\00\11P\00\00\00\00\01")
        if self.led2_button == False and self.led1_button:
            self.color_led_label.config(bg = self.tcp_app.led1_color)
        elif self.led2_button and self.led1_button:
            self.perform_both()
        
    def toggle_led1_off(self):
        self.led1_button = False
        self.toggle_led("AERO\03\00\11P\00\00\00\00\00")
        if self.led1_button == False and self.led2_button == False:
            self.color_led_label.config(bg = self.tcp_app.standby_color)
        elif self.led1_button == False and self.led2_button:
            self.color_led_label.config(bg = self.tcp_app.led2_color)
        else:
            self.color_led_label.config(bg = self.tcp_app.standby_color)
        
    def toggle_led2_on(self):
        self.led2_button = True
        self.toggle_led("AERO\03\00\11P\00\00\00\01\01")
        if self.led1_button == False and self.led2_button:
            self.color_led_label.config(bg = self.tcp_app.led2_color)
        elif self.led1_button and self.led2_button:
            self.perform_both()
        
    def toggle_led2_off(self):
        self.led2_button = False
        self.toggle_led("AERO\03\00\11P\00\00\00\01\00")
        if self.led1_button == False and self.led2_button == False:
            self.color_led_label.config(bg = self.tcp_app.standby_color)
        elif self.led2_button == False and self.led1_button:
            self.color_led_label.config(bg = self.tcp_app.led1_color)
        else:
            self.color_led_label.config(bg = self.tcp_app.standby_color)
    
    def perform_both(self):
        if self.led1_button and self.led2_button:
            if self.color_led_label.cget("bg") == self.tcp_app.led1_color:
                self.color_led_label.config(bg = self.tcp_app.led2_color)
            else:
                self.color_led_label.config(bg = self.tcp_app.led1_color)
            self.master.after(500, self.perform_both)
        
    def toggle_led(self, command):
        error = False
        s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        try:
            s.connect((self.ip, 2009))
            s.send(command.encode())
            s.close()
            error = False
        except Exception as e:
            error = True
            self.error_label.config(text = "Error: " + str(e), fg = "red")

        if not error:
            self.error_label.config(text = "Error: none", fg = "green")

class TCPApp:
    def __init__(self, master):
        self.auto_flag = False
        self.auto_interval = 260
        self.led1_button = False
        self.led2_button = False
        self.connected = False
        self.led1_color = ""
        self.led2_color = ""
        self.standby_color = ""
        
        self.server_address = ("", 0)
        self.master = master
        master.title("TCP LED Control App")
        master.geometry("420x620")
        master.config(bg = "black")
        
        self.link1 = tk.Label(master = master, text = "AeroAudio.eu", bg = "black", fg = "aqua", cursor = "hand2")
        font = tkFont.Font(self.link1, self.link1.cget("font"))
        font.configure(underline = True)
        self.link1.configure(font = font)
        self.link1.bind("<Button>", lambda e: self.link("https://www.aeroaudio.eu/"))
        self.link1.bind("<Enter>", self.link_on_enter)
        self.link1.bind("<Leave>", self.link_on_leave)
        self.image = tk.PhotoImage(file = "Logo_AeroAudio.png").subsample(2)
        self.image_label = tk.Label(master = master, image = self.image, bg = "black")
        
        self.current_color = tk.Label(master = master, text = "Current color:", bg = "black", fg = "white")
        self.color_led_label = tk.Label(master = master, padx = 15, pady = 5)
        
        self.auto_label = tk.Label(master = master, text = "Automatic disabled", bg = "black", fg = "white")
        self.auto_button = tk.Button(master = master, text = "Automatic", command = self.toggle_auto, width = 15, cursor = "hand2")
        self.auto_button.bind("<Enter>", self.auto_on_enter)
        self.auto_button.bind("<Leave>", self.auto_on_leave)
        self.stop_auto_button = tk.Button(master = master, text = "Stop Automatic", command = self.stop_auto, width = 15, cursor = "hand2")
        self.stop_auto_button.bind("<Enter>", self.stop_auto_on_enter)
        self.stop_auto_button.bind("<Leave>", self.stop_auto_on_leave)
        
        self.led1_on_button = tk.Button(master = master, text = "LED1 on", command = self.toggle_led1_on, bg = "white", fg = "black", cursor = "hand2", width = 7)
        self.led1_off_button = tk.Button(master = master, text = "LED1 off", command = self.toggle_led1_off, bg = "white", fg = "black", cursor = "hand2", width = 7)
        self.led2_on_button = tk.Button(master = master, text = "LED2 on", command = self.toggle_led2_on, bg = "white", fg = "black", cursor = "hand2", width = 7)
        self.led2_off_button = tk.Button(master = master, text = "LED2 off", command = self.toggle_led2_off, bg = "white", fg = "black", cursor = "hand2", width = 7)
        
        self.led1_status = tk.Label(master = master, text = "LED1 Status:", bg = "black", fg = "white")
        self.led1_status_label = tk.Label(master = master, text = "Standby", bg = "black", fg = "white")
        self.led2_status = tk.Label(master = master, text = "LED2 Status:", bg = "black", fg = "white")
        self.led2_status_label = tk.Label(master = master, text = "Standby", bg = "black", fg = "white")
        
        self.error_label = tk.Label(master = master, text = "Error: none", bg = "black", fg = "lime green")

        self.exit_label = tk.Label(master = master, text = "Exit:", bg = "black", fg = "white")
        self.close_img = tk.PhotoImage(file="home.png").subsample(10)
        self.exit_button = tk.Button(master = master, image = self.close_img, command = self.close_led_control, bg = "black", activebackground = "black", cursor = "hand2")
        
        self.link1.grid(row = 0, column = 2, columnspan = 2)
        tk.Label(master = master, height = 1, bg = "black").grid(row = 1, column = 0)
        self.image_label.grid(row = 2, column = 2, columnspan = 2)
        tk.Label(master = master, width = 2, bg = "black").grid(row = 2, column = 0)
        tk.Label(master = master, width = 2, bg = "black").grid(row = 2, column = 4)
        tk.Label(master = master, height = 1, bg = "black").grid(row = 3, column = 0)
        self.current_color.grid(row = 4, column = 2, columnspan = 2)
        self.color_led_label.grid(row = 5, column = 2, columnspan = 2)
        tk.Label(master = master, height = 1, bg = "black").grid(row = 6, column = 0)
        self.auto_label.grid(row = 7, column = 2, columnspan = 2)
        self.auto_button.grid(row = 8, column = 2, columnspan = 2)
        self.stop_auto_button.grid(row = 9, column = 2, columnspan = 2)
        tk.Label(master = master, height = 1, bg = "black").grid(row = 10, column = 0)
        tk.Label(master = master, text = "LED1:", bg = "black", fg = "white").grid(row = 11, column = 1, columnspan = 2)
        tk.Label(master = master, text = "LED2:", bg = "black", fg = "white").grid(row = 11, column = 3, columnspan = 2)
        self.led1_on_button.grid(row = 12, column = 1, columnspan = 2)
        self.led1_off_button.grid(row = 13, column = 1, columnspan = 2)
        self.led2_on_button.grid(row = 12, column = 3, columnspan = 2)
        self.led2_off_button.grid(row = 13, column = 3, columnspan = 2)
        tk.Label(master = master, height = 1, bg = "black").grid(row = 14, column = 0)
        self.exit_label.grid(row = 16, column = 2, columnspan = 2)
        self.error_label.grid(row = 15, column = 2, columnspan = 2)
        self.exit_button.grid(row = 17, column = 2, columnspan = 2)
    
    def check_and_assign_ip(self, entered_ip, led1_color, led2_color, standby_color, protocol):
        if protocol == "TCP":
            if self.is_valid_ip(entered_ip):
                self.assign_ip(entered_ip)
                self.connected = True
                self.show_led_control()
                self.setup_led_colors(led1_color, led2_color, standby_color)
                return True
            else:
                return False
        elif protocol == "DHD":
            self.assign_ip(entered_ip)
            self.connected = True
            self.setup_led_colors(led1_color, led2_color, standby_color)
            self.open_dhd_entry_window()
            return True
        else:
            self.error_label.config(text = "Select a protocol", fg = "red")
            return False

    def setup_led_colors(self, led1_color, led2_color, standby_color):
        self.led1_color = led1_color
        self.led2_color = led2_color
        self.standby_color = standby_color
        self.color_led_label.config(bg = self.standby_color)
        self.auto_button.config(bg = self.led1_color, activebackground = self.led2_color)
        self.stop_auto_button.config(bg = self.led2_color, activebackground = self.led1_color)

    def open_ip_entry_window(self):
        ip_entry_window = tk.Toplevel(self.master)
        IPEntryWindow(ip_entry_window, self.check_and_assign_ip)
        
    def open_dhd_entry_window(self):
        dhd_entry_window = tk.Toplevel(self.master)
        DHDEntryWindow(dhd_entry_window, self)

    def show_led_control(self):
        if self.connected:
            self.master.deiconify()
    
    def assign_ip(self, ip):
        self.server_address = (ip, 93)
        print(f"Assigned IP address: {ip}")
        self.error_label.config(text = "Error: none", fg = "green")
        time.sleep(0.1)
        self.toggle_led("Off1")
        time.sleep(0.2)
        self.toggle_led("Off2")

    def is_valid_ip(self, ip):
        try:
            socket.create_connection((ip, 93), timeout = 1)
            return True
        except (socket.error, socket.timeout):
            return False

    def link(self, url):
        webbrowser.get("C:/Program Files/Google/Chrome/Application/chrome.exe %s").open(url)
    
    def link_on_enter(self, e):
        self.link1.config(fg = "light blue")

    def link_on_leave(self, e):
        self.link1.config(fg = "aqua")

    def auto_on_enter(self, e):
        self.auto_button.config(bg = self.led2_color)

    def auto_on_leave(self, e):
        self.auto_button.config(bg = self.led1_color)
        
    def stop_auto_on_enter(self, e):
        self.stop_auto_button.config(bg = self.led1_color)

    def stop_auto_on_leave(self, e):
        self.stop_auto_button.config(bg = self.led2_color)
    
    def toggle_auto(self):
        if not self.auto_flag:
            self.auto_flag = True
            self.auto_change_color()
        else:
            self.auto_flag = False
    
    def stop_auto(self):
        self.auto_flag = False
        self.toggle_led("Off1")
        time.sleep(0.2)
        self.toggle_led("Off2")
        self.color_led_label.config(bg = self.standby_color)
    
    def auto_change_color(self):
        if self.auto_flag:
            time.sleep(0.1)
            if self.color_led_label.cget("bg") == self.led1_color:
                self.toggle_led("On2")
                self.toggle_led("Off1")
                self.color_led_label.config(bg = self.led2_color)
            else:
                self.toggle_led("On1")
                self.toggle_led("Off2")
                self.color_led_label.config(bg = self.led1_color)
            self.master.after(self.auto_interval, self.auto_change_color)
            
    def close_led_control(self):
        self.master.destroy()
        self.master.quit()

    def toggle_led1_on(self):
        self.led1_button = True
        self.toggle_led("On1")
        if self.led2_button == False and self.led1_button:
            self.color_led_label.config(bg = self.led1_color)
        elif self.led2_button and self.led1_button:
            self.perform_both()
        
    def toggle_led1_off(self):
        self.led1_button = False
        self.toggle_led("Off1")
        if self.led1_button == False and self.led2_button == False:
            self.color_led_label.config(bg = self.standby_color)
        elif self.led1_button == False and self.led2_button:
            self.color_led_label.config(bg = self.led2_color)
        else:
            self.color_led_label.config(bg = self.standby_color)
        
    def toggle_led2_on(self):
        self.led2_button = True
        self.toggle_led("On2")
        if self.led1_button == False and self.led2_button:
            self.color_led_label.config(bg = self.led2_color)
        elif self.led1_button and self.led2_button:
            self.perform_both()
        
    def toggle_led2_off(self):
        self.led2_button = False
        self.toggle_led("Off2")
        if self.led1_button == False and self.led2_button == False:
            self.color_led_label.config(bg = self.standby_color)
        elif self.led2_button == False and self.led1_button:
            self.color_led_label.config(bg = self.led1_color)
        else:
            self.color_led_label.config(bg = self.standby_color)
    
    def perform_both(self):
        if self.led1_button and self.led2_button:
            if self.color_led_label.cget("bg") == self.led1_color:
                self.color_led_label.config(bg = self.led2_color)
            else:
                self.color_led_label.config(bg = self.led1_color)
            self.master.after(500, self.perform_both)

    def toggle_led(self, command):
        error = False
        try:
            s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
            s.settimeout(0.1)
            s.connect(self.server_address)
            s.send(command.encode())
            print(f"Message sent: {command}")
            data = s.recv(1024)
            print("Received response:", data.decode())
            s.close()
        except Exception as e:
            error = True
            if str(e) == "timed out":
                error = False
            else:
                self.error_label.config(text = "Error: " + str(e), fg = "red")

        if not error:
            self.error_label.config(text = "Error: none", fg = "green")
        
root = tk.Tk()
root.withdraw()
app = TCPApp(root)
app.open_ip_entry_window()
root.mainloop()